/* Server Test */
/* Author(s): A. Esnard */
/* Usage: server listen_port */

#include "socket.h"

#include <cstdio>
#include <cstdlib>
#include <unistd.h>
#include <string.h>

using namespace std;

#define LINE 255

/* --------------------------------------------------------- */

class SocketServerTest : public SocketServer 
{
  
public:
  
  SocketServerTest(int port)
    : SocketServer(port) 
  {
    fdclient1 = fdclient2 = -1;
    strcpy(buffer1,"vide");
    strcpy(buffer2,"vide");
  }
  
  virtual void work(int fdw)
  {
    
    /* ==> DEBUT CODE SERVER <== */
    
    if(fdclient1 < 0) fdclient1 = fdw;        /* connexion du premier client  */
    else if(fdclient2 < 0) fdclient2 = fdw;   /* connexion du second client */
    else { printf("warning: new client ignored (fd = %d) !\n", fdw); return; }

    printf("waiting 2 clients...\n");          
    barrier();  // synchro
      
    // server <-> client1
    if(fdw == fdclient1) {
      read(fdclient1, buffer1, LINE);    
      printf("recv from client1: %s\n", buffer1);  
      printf("send to client2: %s\n", buffer1);  
      int w = write(fdclient2, buffer1, LINE); 
      if(w <= 0) perror("write");
    }
    
    // server <-> client2
    if(fdw == fdclient2) {
      read(fdclient2, buffer2, LINE); 
      printf("recv from client2: %s\n", buffer2);  
      printf("send to client1: %s\n", buffer2);        
      int w = write(fdclient1, buffer2, LINE); 
      if(w <= 0) perror("write");
    }

    barrier();  // synchro before to close file descriptors...
    fdclient1 = fdclient2 = -1; // reset for next 2 clients... 

    /* ==> FIN CODE SERVER <== */
  }
  
private:
  char buffer1[LINE];
  char buffer2[LINE];
  int fdclient1;
  int fdclient2;
  
};

/* --------------------------------------------------------- */

int main(int argc, char * argv[]) 
{
  
  if (argc != 2) {
    printf("usage: %s port\n",argv[0]);
    return EXIT_FAILURE;
  }
  
  /* argument(s) */
  int port = atoi(argv[1]);
  
  Socket * server = new SocketServerTest(port);
  server->start();
  
  return EXIT_SUCCESS;
}

/* --------------------------------------------------------- */
